"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAgent = void 0;
const React = __importStar(require("react"));
const react_1 = require("react");
const BasicMessageProvider_1 = __importDefault(require("./BasicMessageProvider"));
const ConnectionProvider_1 = __importDefault(require("./ConnectionProvider"));
const CredentialProvider_1 = __importDefault(require("./CredentialProvider"));
const ProofProvider_1 = __importDefault(require("./ProofProvider"));
const AgentContext = (0, react_1.createContext)(undefined);
const useAgent = () => {
    const agentContext = (0, react_1.useContext)(AgentContext);
    if (!agentContext) {
        throw new Error('useAgent must be used within a AgentContextProvider');
    }
    return agentContext;
};
exports.useAgent = useAgent;
const AgentProvider = ({ agent, children }) => {
    const [agentState, setAgentState] = (0, react_1.useState)({
        loading: true,
        agent,
    });
    const setInitialState = async () => {
        if (agent) {
            setAgentState({ agent, loading: false });
        }
    };
    (0, react_1.useEffect)(() => {
        setInitialState();
    }, [agent]);
    return (React.createElement(AgentContext.Provider, { value: agentState },
        React.createElement(ConnectionProvider_1.default, { agent: agent },
            React.createElement(CredentialProvider_1.default, { agent: agent },
                React.createElement(ProofProvider_1.default, { agent: agent },
                    React.createElement(BasicMessageProvider_1.default, { agent: agent }, children))))));
};
exports.default = AgentProvider;
//# sourceMappingURL=AgentProvider.js.map