"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBasicMessagesByConnectionId = exports.useBasicMessages = void 0;
const core_1 = require("@aries-framework/core");
const React = __importStar(require("react"));
const react_1 = require("react");
const BasicMessageContext = (0, react_1.createContext)(undefined);
const useBasicMessages = () => {
    const basicMessageContext = (0, react_1.useContext)(BasicMessageContext);
    if (!basicMessageContext) {
        throw new Error('useBasicMessages must be used within a BasicMessageContextProvider');
    }
    return basicMessageContext;
};
exports.useBasicMessages = useBasicMessages;
const useBasicMessagesByConnectionId = (connectionId) => {
    const { basicMessages } = (0, exports.useBasicMessages)();
    const messages = (0, react_1.useMemo)(() => basicMessages.filter((m) => m.connectionId === connectionId), [basicMessages, connectionId]);
    return messages;
};
exports.useBasicMessagesByConnectionId = useBasicMessagesByConnectionId;
const BasicMessageProvider = ({ agent, children }) => {
    const [basicMessageState, setBasicMessageState] = (0, react_1.useState)({
        basicMessages: [],
        loading: true,
    });
    const setInitialState = async () => {
        if (agent) {
            const basicMessages = await agent.basicMessages.findAllByQuery({});
            setBasicMessageState({ basicMessages, loading: false });
        }
    };
    (0, react_1.useEffect)(() => {
        setInitialState();
    }, [agent]);
    (0, react_1.useEffect)(() => {
        if (!basicMessageState.loading) {
            const listener = (event) => {
                const newBasicMessageState = [...basicMessageState.basicMessages];
                const index = newBasicMessageState.findIndex((basicMessage) => basicMessage.id === event.payload.basicMessageRecord.id);
                if (index > -1) {
                    newBasicMessageState[index] = event.payload.basicMessageRecord;
                }
                else {
                    newBasicMessageState.unshift(event.payload.basicMessageRecord);
                }
                setBasicMessageState({
                    loading: basicMessageState.loading,
                    basicMessages: newBasicMessageState,
                });
            };
            agent === null || agent === void 0 ? void 0 : agent.events.on(core_1.BasicMessageEventTypes.BasicMessageStateChanged, listener);
            return () => {
                agent === null || agent === void 0 ? void 0 : agent.events.off(core_1.BasicMessageEventTypes.BasicMessageStateChanged, listener);
            };
        }
    }, [basicMessageState, agent]);
    return React.createElement(BasicMessageContext.Provider, { value: basicMessageState }, children);
};
exports.default = BasicMessageProvider;
//# sourceMappingURL=BasicMessageProvider.js.map