"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCredentialByState = exports.useCredentialById = exports.useCredentials = void 0;
const core_1 = require("@aries-framework/core");
const React = __importStar(require("react"));
const react_1 = require("react");
const CredentialContext = (0, react_1.createContext)(undefined);
const useCredentials = () => {
    const credentialContext = (0, react_1.useContext)(CredentialContext);
    if (!credentialContext) {
        throw new Error('useCredentials must be used within a CredentialContextProvider');
    }
    return credentialContext;
};
exports.useCredentials = useCredentials;
const useCredentialById = (id) => {
    const { credentials } = (0, exports.useCredentials)();
    return credentials.find((c) => c.id === id);
};
exports.useCredentialById = useCredentialById;
const useCredentialByState = (state) => {
    const { credentials } = (0, exports.useCredentials)();
    const filteredCredentials = (0, react_1.useMemo)(() => credentials.filter((c) => c.state === state), [credentials, state]);
    return filteredCredentials;
};
exports.useCredentialByState = useCredentialByState;
const CredentialProvider = ({ agent, children }) => {
    const [credentialState, setCredentialState] = (0, react_1.useState)({
        credentials: [],
        loading: true,
    });
    const setInitialState = async () => {
        if (agent) {
            const credentials = await agent.credentials.getAll();
            setCredentialState({ credentials, loading: false });
        }
    };
    (0, react_1.useEffect)(() => {
        setInitialState();
    }, [agent]);
    (0, react_1.useEffect)(() => {
        if (!credentialState.loading) {
            const listener = async (event) => {
                const newCredentialsState = [...credentialState.credentials];
                const index = newCredentialsState.findIndex((credential) => credential.id === event.payload.credentialRecord.id);
                if (index > -1) {
                    newCredentialsState[index] = event.payload.credentialRecord;
                }
                else {
                    newCredentialsState.unshift(event.payload.credentialRecord);
                }
                setCredentialState({
                    loading: credentialState.loading,
                    credentials: newCredentialsState,
                });
            };
            agent === null || agent === void 0 ? void 0 : agent.events.on(core_1.CredentialEventTypes.CredentialStateChanged, listener);
            return () => {
                agent === null || agent === void 0 ? void 0 : agent.events.off(core_1.CredentialEventTypes.CredentialStateChanged, listener);
            };
        }
    }, [credentialState, agent]);
    return React.createElement(CredentialContext.Provider, { value: credentialState }, children);
};
exports.default = CredentialProvider;
//# sourceMappingURL=CredentialProvider.js.map