"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useProofByState = exports.useProofById = exports.useProofs = void 0;
const core_1 = require("@aries-framework/core");
const React = __importStar(require("react"));
const react_1 = require("react");
const ProofContext = (0, react_1.createContext)(undefined);
const useProofs = () => {
    const proofContext = (0, react_1.useContext)(ProofContext);
    if (!proofContext) {
        throw new Error('useProofs must be used within a ProofContextProvider');
    }
    return proofContext;
};
exports.useProofs = useProofs;
const useProofById = (id) => {
    const { proofs } = (0, exports.useProofs)();
    return proofs.find((p) => p.id === id);
};
exports.useProofById = useProofById;
const useProofByState = (state) => {
    const { proofs } = (0, exports.useProofs)();
    const filteredProofs = (0, react_1.useMemo)(() => proofs.filter((p) => p.state === state), [proofs, state]);
    return filteredProofs;
};
exports.useProofByState = useProofByState;
const ProofProvider = ({ agent, children }) => {
    const [proofState, setProofState] = (0, react_1.useState)({
        proofs: [],
        loading: true,
    });
    const setInitialState = async () => {
        if (agent) {
            const proofs = await agent.proofs.getAll();
            setProofState({ proofs, loading: false });
        }
    };
    (0, react_1.useEffect)(() => {
        setInitialState();
    }, [agent]);
    (0, react_1.useEffect)(() => {
        if (!proofState.loading) {
            const listener = (event) => {
                const newProofsState = [...proofState.proofs];
                const index = newProofsState.findIndex((proof) => proof.id === event.payload.proofRecord.id);
                if (index > -1) {
                    newProofsState[index] = event.payload.proofRecord;
                }
                else {
                    newProofsState.unshift(event.payload.proofRecord);
                }
                setProofState({
                    loading: proofState.loading,
                    proofs: newProofsState,
                });
            };
            agent === null || agent === void 0 ? void 0 : agent.events.on(core_1.ProofEventTypes.ProofStateChanged, listener);
            return () => {
                agent === null || agent === void 0 ? void 0 : agent.events.off(core_1.ProofEventTypes.ProofStateChanged, listener);
            };
        }
    }, [proofState, agent]);
    return React.createElement(ProofContext.Provider, { value: proofState }, children);
};
exports.default = ProofProvider;
//# sourceMappingURL=ProofProvider.js.map